 typedef long int ptrdiff_t;
        typedef long unsigned int size_t;
        namespace std {
       inline namespace __1 {
      template <class _Tp, _Tp __v> struct __attribute__ ((__type_visibility__0)) integral_constant {
       static constexpr const _Tp value = __v;
        };
      typedef integral_constant<bool, false> false_type;
      template <bool _Val> using _BoolConstant __attribute__((__nodebug__)) = integral_constant<bool, _Val>;
      template <bool, class _Tp = void> struct __attribute__ ((__type_visibility__0)) enable_if ;
      template <bool _Bp, class _Tp = void> using __enable_if_t __attribute__((__nodebug__)) = typename enable_if<_Bp, _Tp>::type;
      template <bool _Bp, class _Tp = void> using enable_if_t = typename enable_if<_Bp, _Tp>::type;
      template <bool> struct _MetaBase;
      template <> struct _MetaBase<true> ;
      template <template <class ...> class _Templ, class ..._Args> using _IsValidExpansion __attribute__((__nodebug__)) = decltype(__sfinae_test_impl<_Templ, _Args...>(0));
      template <bool _Bp, class _If, class _Then>     struct __attribute__ ((__type_visibility__0)) conditional ;
      template <bool _Bp, class _If, class _Then> using conditional_t = typename conditional<_Bp, _If, _Then>::type;
      template <class _Tp, class _Up> struct __attribute__ ((__type_visibility__0)) is_same : _BoolConstant<__is_same(_Tp, _Up)> {
     };
      template <class _Tp, class _Up> inline constexpr bool is_same_v = __is_same(_Tp, _Up);
      template <class _Tp, class _Up> using _IsSame = _BoolConstant<__is_same(_Tp, _Up)>;
      template <class _Tp, class _Up> using _IsNotSame = _BoolConstant<!__is_same(_Tp, _Up)>;
      template <class _Tp> using __test_for_primary_template = __enable_if_t<     _IsSame<_Tp, typename _Tp::__primary_template>::value   >;
      template <class _Tp> using __is_primary_template = _IsValidExpansion<     __test_for_primary_template, _Tp   >;
      struct __two ;
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) is_const : _BoolConstant<__is_const(_Tp)> {
     };
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) is_volatile : _BoolConstant<__is_volatile(_Tp)> {
     };
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) remove_const {
    typedef _Tp type;
    };
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) remove_volatile {
    typedef _Tp type;
    };
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) remove_cv {
    typedef typename remove_volatile<typename remove_const<_Tp>::type>::type type;
    };
      template <class _Tp> using remove_cv_t = typename remove_cv<_Tp>::type;
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) is_void : _BoolConstant<__is_void(_Tp)> {
     };
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) is_integral : _BoolConstant<__is_integral(_Tp)> {
     };
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) is_array     : public false_type {
    };
      template <class _Tp> inline constexpr bool is_array_v = is_array<_Tp>::value;
      template <class _Tp> inline constexpr bool is_pointer_v = __is_pointer(_Tp);
      template <class _Tp> inline constexpr bool is_lvalue_reference_v = __is_lvalue_reference(_Tp);
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) is_union     : public integral_constant<bool, __is_union(_Tp)> {
    };
      template <class _Tp> inline constexpr bool is_union_v = is_union<_Tp>::value;
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) is_class     : public integral_constant<bool, __is_class(_Tp)> {
    };
      template <class _Tp> inline constexpr bool is_class_v = is_class<_Tp>::value;
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) is_function     : public _BoolConstant<     __is_function(_Tp)     > {
    };
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) is_enum     : public integral_constant<bool, __is_enum(_Tp)> {
    };
      template <class _Tp> inline constexpr bool is_enum_v = __is_enum(_Tp);
      template <class _Tp> inline constexpr bool is_object_v = __is_object(_Tp);
      struct __is_referenceable_impl {
         template <class _Tp> static _Tp& __test(int);
     };
      template <class _Tp> struct __is_referenceable : integral_constant<bool,     _IsNotSame<decltype(__is_referenceable_impl::__test<_Tp>(0)), __two>::value> {
     };
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) remove_reference {
    typedef __attribute__((__nodebug__)) _Tp type;
    };
      template <class _Tp> using remove_reference_t = typename remove_reference<_Tp>::type;
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) add_rvalue_reference ;
      template <class _Tp> using __uncvref_t __attribute__((__nodebug__)) = typename remove_cv<typename remove_reference<_Tp>::type>::type;
      template <class _Tp, class _Up> struct __is_same_uncvref : _IsSame<__uncvref_t<_Tp>, __uncvref_t<_Up> > {
    };
      template <class _Tp> struct remove_cvref {
         using type __attribute__((__nodebug__)) = __uncvref_t<_Tp>;
     };
      template <class _Tp> using remove_cvref_t = typename remove_cvref<_Tp>::type;
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) add_pointer     ;
      template <class _Tp> using add_pointer_t = typename add_pointer<_Tp>::type;
      template <class _Up, bool> struct __decay {
         typedef __attribute__((__nodebug__)) typename remove_cv<_Up>::type type;
     };
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) decay {
     private:     typedef __attribute__((__nodebug__)) typename remove_reference<_Tp>::type _Up;
     public:     typedef __attribute__((__nodebug__)) typename __decay<_Up, __is_referenceable<_Up>::value>::type type;
    };
      template <class _Bp, class _Dp> struct __attribute__ ((__type_visibility__0)) is_base_of     : public integral_constant<bool, __is_base_of(_Bp, _Dp)> {
    };
      template <class _Bp, class _Dp> inline constexpr bool is_base_of_v = is_base_of<_Bp, _Dp>::value;
      template <class _T1, class _T2> struct __attribute__ ((__type_visibility__0)) is_convertible     : public integral_constant<bool, __is_convertible_to(_T1, _T2)> {
    };
      template <class _From, class _To> inline constexpr bool is_convertible_v = is_convertible<_From, _To>::value;
      template <class _Hp, class _Tp> struct __type_list {
         typedef _Hp _Head;
     };
      struct __nat ;
      typedef     __type_list<unsigned char,     __type_list<unsigned short,     __type_list<unsigned int,     __type_list<unsigned long,     __type_list<unsigned long long,     __type_list<__uint128_t,     __nat     >     > > > > > __unsigned_types;
      template <class _TypeList, size_t _Size, bool = _Size <= sizeof(typename _TypeList::_Head)> struct __find_first;
      template <class _Hp, class _Tp, size_t _Size> struct __find_first<__type_list<_Hp, _Tp>, _Size, true> {
         typedef __attribute__((__nodebug__)) _Hp type;
     };
      template <class _Hp, class _Tp, size_t _Size> struct __find_first<__type_list<_Hp, _Tp>, _Size, false> {
         typedef __attribute__((__nodebug__)) typename __find_first<_Tp, _Size>::type type;
     };
      template <class _Tp, class _Up, bool = is_const<typename remove_reference<_Tp>::type>::value,                              bool = is_volatile<typename remove_reference<_Tp>::type>::value> struct __apply_cv {
         typedef __attribute__((__nodebug__)) _Up type;
     };
      template <class _Tp, bool = is_integral<_Tp>::value || is_enum<_Tp>::value> struct __make_unsigned {
         typedef typename __find_first<__unsigned_types, sizeof(_Tp)>::type type;
     };
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) make_unsigned {
         typedef typename __apply_cv<_Tp, typename __make_unsigned<typename remove_cv<_Tp>::type>::type>::type type;
     };
      template <class...> struct common_reference;
      template <class... _Types> using common_reference_t = typename common_reference<_Types...>::type;
      template <class _Tp, bool> struct __destructible_false;
      template <class _Tp> struct is_destructible     : public __destructible_false<_Tp, is_function<_Tp>::value> {
    };
      template <class _Tp, class ..._Args> struct __attribute__ ((__type_visibility__0)) is_constructible     : public integral_constant<bool, __is_constructible(_Tp, _Args...)> {
     };
      template <class _Tp, class ..._Args> inline constexpr bool is_constructible_v = is_constructible<_Tp, _Args...>::value;
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) __libcpp_is_trivially_relocatable     : public integral_constant<bool,     __is_trivially_relocatable(_Tp)     > {
    };
      template <class _Tp, class... _Args> struct __attribute__ ((__type_visibility__0)) is_nothrow_constructible     : public integral_constant<bool, __is_nothrow_constructible(_Tp, _Args...)> {
    };
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) is_nothrow_move_constructible     : public is_nothrow_constructible<_Tp, typename add_rvalue_reference<_Tp>::type>     {
    };
      template <class _Tp, class _Arg> struct __attribute__ ((__type_visibility__0)) is_nothrow_assignable     : public integral_constant<bool, __is_nothrow_assignable(_Tp, _Arg)> {
    };
      template <bool, class _Tp> struct __libcpp_is_nothrow_destructible;
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) is_nothrow_destructible     : public __libcpp_is_nothrow_destructible<is_destructible<_Tp>::value, _Tp> {
     };
      template <class _Tp> inline constexpr bool is_nothrow_destructible_v = is_nothrow_destructible<_Tp>::value;
      template<class _Tp> using __make_const_lvalue_ref = const typename remove_reference<_Tp>::type&;
      template <class _Tp>                        __attribute__ ((__visibility__0)) __attribute__ ((__exclude_from_explicit_instantiation__)) constexpr _Tp&& forward(typename remove_reference<_Tp>::type& __t) noexcept ;
      template <class _Tp> struct __attribute__ ((__type_visibility__0)) pointer_traits<_Tp*> {
         typedef ptrdiff_t difference_type;
         template <class _Up> using rebind = _Up*;
     public:      };
      template <class _Tp>  __attribute__ ((__visibility__0)) __attribute__ ((__exclude_from_explicit_instantiation__)) constexpr auto to_address(_Tp *__p) noexcept ;
      }
       inline namespace __1 {
      template <class _Tp, class = void> struct __has_pointer : false_type {
     };
      template <class _Tp, class _Alloc,           class _RawAlloc = typename remove_reference<_Alloc>::type,           bool = __has_pointer<_RawAlloc>::value> struct __pointer {
         using type __attribute__((__nodebug__)) = _Tp*;
     };
      template <class _Tp, class = void> struct __has_const_pointer : false_type {
     };
      template <class _Tp, class _Ptr, class _Alloc,           bool = __has_const_pointer<_Alloc>::value> struct __const_pointer ;
      template <class _Tp, class _Ptr, class _Alloc> struct __const_pointer<_Tp, _Ptr, _Alloc, false> {
         using type __attribute__((__nodebug__)) = typename pointer_traits<_Ptr>::template rebind<const _Tp>;
     };
      template <class _Tp, class = void> struct __has_size_type : false_type {
     };
      template <class _Alloc, class _DiffType, bool = __has_size_type<_Alloc>::value> struct __size_type : make_unsigned<_DiffType> {
     };
      template <class _Tp, class = void> struct __has_alloc_traits_difference_type : false_type {
     };
      template <class _Alloc, class _Ptr, bool = __has_alloc_traits_difference_type<_Alloc>::value> struct __alloc_traits_difference_type {
         using type __attribute__((__nodebug__)) = typename pointer_traits<_Ptr>::difference_type;
     };
      template <class _Alloc> struct __attribute__ ((__type_visibility__0)) allocator_traits {
         using allocator_type = _Alloc;
         using value_type = typename allocator_type::value_type;
         using pointer = typename __pointer<value_type, allocator_type>::type;
         using const_pointer = typename __const_pointer<value_type, pointer, allocator_type>::type;
         using difference_type = typename __alloc_traits_difference_type<allocator_type, pointer>::type;
         using size_type = typename __size_type<allocator_type, difference_type>::type;
     };
      template <class> class allocator;
      }
       inline namespace __1 {
      template <class _Pointer> struct allocation_result ;
      template<class _CharT> struct __attribute__ ((__type_visibility__0)) char_traits;
      template <class _CharT,           class _Traits = char_traits<_CharT>,           class _Allocator = allocator<_CharT> >     class __attribute__ ((__type_visibility__0)) basic_string;
      template <bool _Cond, class _Unique> struct __non_trivial_if {
     };
      template <class _Tp> class __attribute__ ((__type_visibility__0)) allocator     : private __non_trivial_if<!is_void<_Tp>::value, allocator<_Tp> > {
     public:     typedef size_t size_type;
         typedef _Tp value_type;
     };
      }
       inline namespace __1 {
      template<class _From, class _To> concept convertible_to =   is_convertible_v<_From, _To> &&   requires {
         static_cast<_To>(declval<_From>());
       };
      template<class _Tp, class _Up> concept __same_as_impl = _IsSame<_Tp, _Up>::value;
      template<class _Tp, class _Up> concept same_as = __same_as_impl<_Tp, _Up> && __same_as_impl<_Up, _Tp>;
      template<class _Tp, class _Up> concept common_reference_with =   same_as<common_reference_t<_Tp, _Up>, common_reference_t<_Up, _Tp>> &&   convertible_to<_Tp, common_reference_t<_Tp, _Up>> &&   convertible_to<_Up, common_reference_t<_Tp, _Up>>;
      }
       inline namespace __1 {
      template<class _Tp> concept __boolean_testable_impl = convertible_to<_Tp, bool>;
      template<class _Tp> concept __boolean_testable = __boolean_testable_impl<_Tp> && requires(_Tp&& __t) {
       {
    !std::forward<_Tp>(__t) }
     -> __boolean_testable_impl;
     };
      }
       inline namespace __1 {
      template<class _Tp, class _Up> concept __weakly_equality_comparable_with =   requires(__make_const_lvalue_ref<_Tp> __t, __make_const_lvalue_ref<_Up> __u) {
         {
    __t == __u }
     -> __boolean_testable;
       };
      template<class _Tp> concept equality_comparable = __weakly_equality_comparable_with<_Tp, _Tp>;
      }
       inline namespace __1 {
      template<class _Tp, class _Up> concept __partially_ordered_with =   requires(__make_const_lvalue_ref<_Tp> __t, __make_const_lvalue_ref<_Up> __u) {
         {
    __t < __u }
     -> __boolean_testable;
       };
      template<class _Tp> concept totally_ordered = equality_comparable<_Tp> && __partially_ordered_with<_Tp, _Tp>;
      }
       inline namespace __1 {
      struct __attribute__ ((__type_visibility__0)) piecewise_construct_t ;
      template<size_t _Ip> struct __priority_tag : __priority_tag<_Ip - 1> {
    };
      template<> struct __priority_tag<0> {
     };
      }
       inline namespace __1 {
      template<class _Lhs, class _Rhs> concept assignable_from =   is_lvalue_reference_v<_Lhs> &&   common_reference_with<__make_const_lvalue_ref<_Lhs>, __make_const_lvalue_ref<_Rhs>> &&   requires (_Lhs __lhs, _Rhs&& __rhs) {
         {
    __lhs = std::forward<_Rhs>(__rhs) }
     -> same_as<_Lhs>;
       };
      template<class _Tp> concept __class_or_enum = bool(is_class_v<_Tp> || is_union_v<_Tp> || is_enum_v<_Tp>);
      template<class _Tp> concept destructible = is_nothrow_destructible_v<_Tp>;
      template<class _Tp, class... _Args> concept constructible_from =     destructible<_Tp> && is_constructible_v<_Tp, _Args...>;
      template<class _Tp> concept __default_initializable = requires {
     ::new _Tp;
     };
      template<class _Tp> concept default_initializable = constructible_from<_Tp> &&     requires {
     _Tp{
   };
     }
      && __default_initializable<_Tp>;
      template<class _Tp> concept move_constructible =   constructible_from<_Tp, _Tp> && convertible_to<_Tp, _Tp>;
      template<class _Tp> concept copy_constructible =   move_constructible<_Tp> &&   constructible_from<_Tp, _Tp&> && convertible_to<_Tp&, _Tp> &&   constructible_from<_Tp, const _Tp&> && convertible_to<const _Tp&, _Tp> &&   constructible_from<_Tp, const _Tp> && convertible_to<const _Tp, _Tp>;
      }
       inline namespace __1 {
       ;
      template<class _Tp> concept swappable = requires(_Tp& __a, _Tp& __b) {
     };
      template<class _Tp> concept movable =   is_object_v<_Tp> &&   move_constructible<_Tp> &&   assignable_from<_Tp&, _Tp> &&   swappable<_Tp>;
      }
       }
        namespace std {
      template<class _Tp> concept copyable =   copy_constructible<_Tp> &&   movable<_Tp> &&   assignable_from<_Tp&, _Tp&> &&   assignable_from<_Tp&, const _Tp&> &&   assignable_from<_Tp&, const _Tp>;
      template<class _Dp, class _Bp> concept derived_from =   is_base_of_v<_Bp, _Dp> &&   is_convertible_v<const volatile _Dp*, const volatile _Bp*>;
      }
        namespace std {
       inline namespace __1 {
      template<class _Tp> concept semiregular = copyable<_Tp> && default_initializable<_Tp>;
      template<class _Tp> concept regular = semiregular<_Tp> && equality_comparable<_Tp>;
      template<class> struct incrementable_traits ;
      template <class> struct iterator_traits;
      template <class _Ip> using iter_difference_t = typename conditional_t<__is_primary_template<iterator_traits<remove_cvref_t<_Ip> > >::value,                                                  incrementable_traits<remove_cvref_t<_Ip> >,                                                  iterator_traits<remove_cvref_t<_Ip> > >::difference_type;
      template<class> struct indirectly_readable_traits ;
      template <class _Ip> using iter_value_t = typename conditional_t<__is_primary_template<iterator_traits<remove_cvref_t<_Ip> > >::value,                                             indirectly_readable_traits<remove_cvref_t<_Ip> >,                                             iterator_traits<remove_cvref_t<_Ip> > >::value_type;
      template <class _Tp> using __with_reference = _Tp&;
      template <class _Tp> concept __can_reference = requires {
       typename __with_reference<_Tp>;
     };
      template <class _Tp> concept __dereferenceable = requires(_Tp& __t) {
       {
     *__t }
     -> __can_reference;
     };
      template<__dereferenceable _Tp> using iter_reference_t = decltype(*declval<_Tp&>());
      struct __attribute__ ((__type_visibility__0)) input_iterator_tag {
    };
      struct __attribute__ ((__type_visibility__0)) forward_iterator_tag : public input_iterator_tag {
    };
      struct __attribute__ ((__type_visibility__0)) bidirectional_iterator_tag : public forward_iterator_tag {
    };
      struct __attribute__ ((__type_visibility__0)) random_access_iterator_tag : public bidirectional_iterator_tag {
    };
      struct __attribute__ ((__type_visibility__0)) contiguous_iterator_tag : public random_access_iterator_tag {
    };
      template <class _Iter> struct __iter_concept_cache ;
      template <class _Iter> using _ITER_CONCEPT = typename __iter_concept_cache<_Iter>::type::template _Apply<_Iter>;
      template<class> struct __iterator_traits_difference_type ;
      template<class _Ip> requires requires {
     typename incrementable_traits<_Ip>::difference_type;
     }
      struct __iterator_traits_difference_type<_Ip> ;
      }
       inline namespace __1 {
      namespace ranges {
     namespace __iter_move {
     template <class _Tp> concept __unqualified_iter_move =   __class_or_enum<remove_cvref_t<_Tp>> &&   requires (_Tp&& __t) {
       iter_move(std::forward<_Tp>(__t));
     };
     struct __fn {
     template<class _Ip>     requires __unqualified_iter_move<_Ip>   [[nodiscard]] __attribute__ ((__visibility__0)) __attribute__ ((__exclude_from_explicit_instantiation__)) constexpr decltype(auto) operator0(_Ip&& __i) const     noexcept(noexcept(iter_move(std::forward<_Ip>(__i))))   ;
   };
     }
     inline namespace __cpo {
       inline constexpr auto iter_move = __iter_move::__fn{
  };
     }
     }
      template<__dereferenceable _Tp>   requires requires(_Tp& __t) {
     {
     ranges::iter_move(__t) }
     -> __can_reference;
     }
      using iter_rvalue_reference_t = decltype(ranges::iter_move(declval<_Tp&>()));
      template<class _In> concept __indirectly_readable_impl =   requires(const _In __i) {
         {
     *__i }
     -> same_as<iter_reference_t<_In>>;
       }
      &&   common_reference_with<iter_reference_t<_In>&&, iter_value_t<_In>&> &&   common_reference_with<iter_reference_t<_In>&&, iter_rvalue_reference_t<_In>&&> &&   common_reference_with<iter_rvalue_reference_t<_In>&&, const iter_value_t<_In>&>;
      template<class _In> concept indirectly_readable = __indirectly_readable_impl<remove_cvref_t<_In>>;
      template<class _Ip> concept weakly_incrementable =   !same_as<_Ip, bool> &&   movable<_Ip> &&   requires(_Ip __i) {
         {
     ++__i }
     -> same_as<_Ip&>;
       };
      template<class _Ip> concept incrementable =   regular<_Ip> &&   weakly_incrementable<_Ip> &&   requires(_Ip __i) {
         {
     __i++ }
     -> same_as<_Ip>;
       };
      template<class _Ip> concept input_or_output_iterator =   requires(_Ip __i) {
         {
     *__i }
     -> __can_reference;
       }
      &&   weakly_incrementable<_Ip>;
      template<class _Sp, class _Ip> concept sentinel_for =   semiregular<_Sp> &&   input_or_output_iterator<_Ip> &&   __weakly_equality_comparable_with<_Sp, _Ip>;
      template<class, class> inline constexpr bool disable_sized_sentinel_for = false;
      template<class _Sp, class _Ip> concept sized_sentinel_for =   sentinel_for<_Sp, _Ip> &&   !disable_sized_sentinel_for<remove_cv_t<_Sp>, remove_cv_t<_Ip>> &&   requires(const _Ip& __i, const _Sp& __s) {
         {
     __s - __i }
     -> same_as<iter_difference_t<_Ip>>;
       };
      template<class _Ip> concept input_iterator =   input_or_output_iterator<_Ip> &&   indirectly_readable<_Ip> &&   requires {
     typename _ITER_CONCEPT<_Ip>;
     }
      &&   derived_from<_ITER_CONCEPT<_Ip>, input_iterator_tag>;
      template<class _Ip> concept forward_iterator =   input_iterator<_Ip> &&   derived_from<_ITER_CONCEPT<_Ip>, forward_iterator_tag> &&   incrementable<_Ip> &&   sentinel_for<_Ip, _Ip>;
      template<class _Ip> concept bidirectional_iterator =   forward_iterator<_Ip> &&   derived_from<_ITER_CONCEPT<_Ip>, bidirectional_iterator_tag> &&   requires(_Ip __i) {
         {
     __i-- }
     -> same_as<_Ip>;
       };
      template<class _Ip> concept random_access_iterator =   bidirectional_iterator<_Ip> &&   derived_from<_ITER_CONCEPT<_Ip>, random_access_iterator_tag> &&   totally_ordered<_Ip> &&   sized_sentinel_for<_Ip, _Ip> &&   requires(_Ip __i, const _Ip __j, const iter_difference_t<_Ip> __n) {
         {
     __i += __n }
     -> same_as<iter_reference_t<_Ip>>;
       };
      template<class _Ip> concept contiguous_iterator =   random_access_iterator<_Ip> &&   derived_from<_ITER_CONCEPT<_Ip>, contiguous_iterator_tag> &&   is_lvalue_reference_v<iter_reference_t<_Ip>> &&   same_as<iter_value_t<_Ip>, remove_cvref_t<iter_reference_t<_Ip>>> &&   requires(const _Ip& __i) {
         {
     std::to_address(__i) }
     -> same_as<add_pointer_t<iter_reference_t<_Ip>>>;
       };
      template<class _Ip> concept __has_arrow = input_iterator<_Ip> && (is_pointer_v<_Ip> || requires(_Ip __i) {
     __i.operator->();
     }
     );
      namespace ranges {
     namespace __begin {
       struct __fn {
       template <class _Tp, enable_if_t<is_array_v<remove_reference_t<_Tp>>>* = nullptr>     __attribute__ ((__visibility__0)) __attribute__ ((__exclude_from_explicit_instantiation__))     static constexpr auto __go(_Tp&& __t, __priority_tag<2>)       noexcept(noexcept(__t + 0))       -> decltype( __t + 0)       ;
       template <class _Tp>     [[nodiscard]] __attribute__ ((__visibility__0)) __attribute__ ((__exclude_from_explicit_instantiation__)) constexpr     decltype(auto) operator()(_Tp&& __t) const       noexcept(noexcept(__go(std::forward<_Tp>(__t), __priority_tag<3>())))       requires (         requires {
             requires (             requires {
                {
  static_cast<typename decay<decltype((__t.begin()))>::type>(__t.begin()) }
  -> input_or_output_iterator;
              }
             );
           }
   ||         is_array_v<remove_reference_t<_Tp>>       ) && requires {
   }
         ;
     };
     }
     inline namespace __cpo {
       inline constexpr auto begin = __begin::__fn{
  };
     }
       template <class _Tp>   using iterator_t = decltype(ranges::begin(declval<_Tp&>()));
     }
      }
      namespace ranges {
     namespace __data {
       };
       inline constexpr auto data = __data::__fn;
       template <class _Tp>   concept range = requires(_Tp& __t) {
         ranges::begin(__t);
       };
       template <class _Tp>   concept input_range = range<_Tp> && input_iterator<iterator_t<_Tp>>;
       template <range _Rp>   using range_value_t = iter_value_t<iterator_t<_Rp>>;
       template <class _Tp>   concept sized_range = range<_Tp> && requires(_Tp& __t) {
     };
       template <class _Tp>   concept forward_range = input_range<_Tp> && forward_iterator<iterator_t<_Tp>>;
       template <class _Tp>   concept bidirectional_range = forward_range<_Tp> && bidirectional_iterator<iterator_t<_Tp>>;
       template <class _Tp>   concept random_access_range =       bidirectional_range<_Tp> && random_access_iterator<iterator_t<_Tp>>;
       template<class _Tp>   concept contiguous_range =     random_access_range<_Tp> &&     contiguous_iterator<iterator_t<_Tp>> &&     requires(_Tp& __t) {
     ranges::data(__t) }
         };
     }
      template <class _Iter> class __wrap_iter {
     public:     typedef _Iter iterator_type;
         typedef typename iterator_traits<iterator_type>::reference reference;
         __attribute__ ((__visibility__0)) __attribute__ ((__exclude_from_explicit_instantiation__)) constexpr reference operator*() const noexcept     ;
        namespace std {
       inline namespace __1 {
      template<class _CharT, class _Traits> class     __attribute__(0)     __attribute__(0)     __attribute__(0)     __attribute__(0)     __attribute__(0)     basic_string_view {
         template <class _Range>       requires (         !is_same_v<remove_cvref_t<_Range>, basic_string_view> &&         ranges::contiguous_range<_Range> &&         ranges::sized_range<_Range> &&         is_same_v<ranges::range_value_t<_Range>, _CharT> &&         !is_convertible_v<_Range, const _CharT*> &&         (!requires(remove_cvref_t<_Range>& d) {
               d.operator std::basic_string_view<_CharT, _Traits>();
             }
     || is_same_v<typename remove_reference_t<_Range>::traits_type, _Traits>)       )     constexpr __attribute__ ((__visibility__0)) __attribute__ ((__exclude_from_explicit_instantiation__))     basic_string_view(_Range&& __r) : __data0, __size0 
     };
      }
       inline namespace __1 {
      template <class _CharT, class _Traits, class _Tp> struct __can_be_converted_to_string_view : public _BoolConstant<       is_convertible<const _Tp&, basic_string_view<_CharT, _Traits> >::value &&      !is_convertible<const _Tp&, const _CharT*>::value     > ;
      template<class _Allocator> struct __basic_string_is_trivially_relocatable ;
      typedef basic_string<char8_t> u8string;
      typedef basic_string<char16_t> u16string;
      typedef basic_string<char32_t> u32string;
      template<class _CharT, class _Traits, class _Allocator> class     __attribute__ ((__type_visibility__0))     __attribute__((__preferred_name__0))     __attribute__((__preferred_name__0))     __attribute__((__preferred_name__0))     [[clang::trivially_relocatable0]]     basic_string {
         typedef _CharT value_type;
         typedef _Allocator allocator_type;
         typedef allocator_traits<allocator_type> __alloc_traits;
         typedef typename __alloc_traits::size_type size_type;
         typedef typename __alloc_traits::const_pointer const_pointer;
         typedef __wrap_iter<const_pointer> const_iterator;
         struct __long     ;;
         enum ;
         struct __short     ;
     public:     __attribute__ (0)     static const size_type npos = -1;
         __attribute__ ((__visibility__0)) __attribute__ ((__exclude_from_explicit_instantiation__)) constexpr     const_iterator begin() const noexcept         ;
         template <class _Tp>     inline __attribute__ ((__visibility__0)) constexpr     __enable_if_t         <             __can_be_converted_to_string_view<_CharT, _Traits, _Tp>::value             && !__is_same_uncvref<_Tp, basic_string>::value,             basic_string&         >                   assign(const _Tp & __t, size_type __pos, size_type __n=npos);
     };
      extern template __attribute__ ((__visibility__0)) basic_string<char>& basic_string<char>::assign(basic_string const&, size_type, size_type);
